// This file was automatically generated. Do not edit this file!
#ifndef INITIALIZER_EXOTICA_CORE_TASK_MAPS_JOINT_ACCELERATION_BACKWARD_DIFFERENCE_INITIALIZER_H
#define INITIALIZER_EXOTICA_CORE_TASK_MAPS_JOINT_ACCELERATION_BACKWARD_DIFFERENCE_INITIALIZER_H

#include <exotica_core/property.h>

namespace exotica
{
inline std::vector<Initializer> GetExoticaCoreTaskMapsInitializers();
}

namespace exotica
{

class JointAccelerationBackwardDifferenceInitializer : public InitializerBase
{
public:
    static std::string GetContainerName() {return "exotica/JointAccelerationBackwardDifference" ;}

    JointAccelerationBackwardDifferenceInitializer() : InitializerBase(),
        Debug( false) ,
        EndEffector( std::vector<exotica::Initializer>()) ,
        StartState( Eigen::VectorXd()) 
    {
    }

    JointAccelerationBackwardDifferenceInitializer( std::string _Name, double _dt, bool _Debug =  false, std::vector<exotica::Initializer> _EndEffector =  std::vector<exotica::Initializer>(), Eigen::VectorXd _StartState =  Eigen::VectorXd()) : InitializerBase(),
        Name(_Name) ,
        dt(_dt) ,
        Debug(_Debug) ,
        EndEffector(_EndEffector) ,
        StartState(_StartState) 
    {
    }

    JointAccelerationBackwardDifferenceInitializer(const Initializer& other) : JointAccelerationBackwardDifferenceInitializer()
    {
        if (other.HasProperty("Name")) {const Property& prop=other.properties_.at("Name"); if(prop.IsSet()) Name = boost::any_cast<std::string>(prop.Get());}
        if (other.HasProperty("dt")) {const Property& prop=other.properties_.at("dt"); if(prop.IsSet()) dt = prop.IsStringType()?ParseDouble(boost::any_cast<std::string>(prop.Get())):boost::any_cast<double>(prop.Get());}
        if (other.HasProperty("Debug")) {const Property& prop=other.properties_.at("Debug"); if(prop.IsSet()) Debug = prop.IsStringType()?ParseBool(boost::any_cast<std::string>(prop.Get())):boost::any_cast<bool>(prop.Get());}
        if (other.HasProperty("EndEffector")) {const Property& prop=other.properties_.at("EndEffector"); if(prop.IsSet()) EndEffector = boost::any_cast<std::vector<exotica::Initializer>>(prop.Get());}
        if (other.HasProperty("StartState")) {const Property& prop=other.properties_.at("StartState"); if(prop.IsSet()) StartState = prop.IsStringType()?ParseVector<double,Eigen::Dynamic>(boost::any_cast<std::string>(prop.Get())):boost::any_cast<Eigen::VectorXd>(prop.Get());}
    }

    virtual Initializer GetTemplate() const
    {
        return (Initializer)JointAccelerationBackwardDifferenceInitializer();
    }

    virtual std::vector<Initializer> GetAllTemplates() const
    {
        return GetExoticaCoreTaskMapsInitializers();
    }

    virtual void Check(const Initializer& other) const
    {
        if(!other.HasProperty("Name") || !other.properties_.at("Name").IsSet()) ThrowPretty("Initializer JointAccelerationBackwardDifferenceInitializer requires property Name to be set!");
        if(!other.HasProperty("dt") || !other.properties_.at("dt").IsSet()) ThrowPretty("Initializer JointAccelerationBackwardDifferenceInitializer requires property dt to be set!");
    }

    operator Initializer()
    {
        Initializer ret(GetContainerName());
        ret.properties_.emplace("Name", Property("Name", true, boost::any(Name)));
        ret.properties_.emplace("dt", Property("dt", true, boost::any(dt)));
        ret.properties_.emplace("Debug", Property("Debug", false, boost::any(Debug)));
        ret.properties_.emplace("EndEffector", Property("EndEffector", false, boost::any(EndEffector)));
        ret.properties_.emplace("StartState", Property("StartState", false, boost::any(StartState)));
        return ret;
    }

    std::string Name;
    double dt;
    bool Debug;
    std::vector<exotica::Initializer> EndEffector;
    Eigen::VectorXd StartState;
};

}

#include<exotica_core_task_maps/exotica_core_task_maps_initializers_numerator.h>

#include <exotica_core/frame_initializer.h>

#endif